//
// pagescriptor.js v1.7.5 16.11.2010 - 03.05.2012 by Gerd Franke franke@sitescriptor.de
/* // Library for dynamic effects showing, hiding, moving content
// depends on prototype.js V1.7
//
//	v1.7.0: neu cascade
//	v1.7.1: neu newtoggle
//	v1.7.2: neu sequencer
//	v1.7.3: cascade: neu autorun
//	v1.7.5: aufgeraeumt 'multi', 'slider' removed
//	v1.7.5: cascade: neu option 'first' 
//
//
// ToDos
//		Cascade: Mitte setzen auf first/last child oder reihenfolge der elemente aendern?
//		Multi: ffnungseffekte? Seitlich...
// 		Alle: AJAX einfhren
//		Toggle: horizontal ffnen
//		Toggle: links im header ermglichen
// 		toggle: cursor auf Hand umschalten
// 		toggle: ps_default container ist offen und immer nur ein Container ist geffnet
// 		slide: slide richtung toggeln
//
// PROBLEME:
// 		Effects mit Queue sequenziell ausfuehren
//		Slider-in-Slider: Next/Prev nicht im Viewport suchen!
//		cascade: probleme bei geraden/ungeraden childs mit option "next"
//
// DONE:
//		sequencer: abbruch der initialisierung, wenn weniger als 2 klassen gegeben.
// 		Multi: bug in 1.7: relativize() funktioniert nicht; Workaround mit setStyle()
// 		Multi: bug: visibleClass nicht bei ps_default gesetzt
// 		Slider: autoshow
// 		Slider: vor- zurueck Buttons
//		Slider: pruefen ob viewport schon absolute
//		Slider: suche nach Links im ganzen container
//		Slider: aktiven Link mit Klassse markieren
//		Async: falsche Schreibweise durch Eigenschaft "pathAttr: 'data-path'" ersetzt
*/ 
//------------------------------------------------------------------------------------------

//--- new class toggle content -------------------------
		
var newToggler;
 //----------
 	var newtoggler = Class.create({
			// user defineable
			toggleAttr:		'data-newtoggle',
			selector: 		'div[data-newtoggle]',
			activeClass:	'newtoggleActive',
			// internal variables, dont change!
			groupHash: 		0,
			// functions
			initialize: function( containerid ) 
				{
	//			alert('newToggler containerid:' + containerid );
				this.groupHash = new Hash();
				$$( containerid + '' + this.selector).each( function(el)
					{ 
					el.addClassName( this.activeClass ); 	
					var newt = new classtoggle( el );	
					if( newt.group )
						{
						var g = newt.group;
			//			alert('Toggle g:' + g );
						if( !this.groupHash.get( g ))
							{
			//				alert('Toggle neuer Hasheintrag' );
							this.groupHash.set( g, [] );
							}
						var gh = this.groupHash.get( g );
						gh.push( newt );
			//			alert('newToggler gh:' + gh.inspect() );
						}
					}, this );
		//		alert('newToggler groupHash:' + this.groupHash.inspect() );
				},
			open: function( gr, tobj ) 
				{
		//		alert( 'newToggler open Group:"' + gr + '"; \nElement:"' + tobj + '";');
		//		alert('newToggler open  groupHash:' + this.groupHash.inspect() );
				if( this.groupHash.get( gr ) )
					{
					var garr = this.groupHash.get( gr );
			//		alert('newToggler open  garr:' + garr.inspect() );
					garr.each( function(te)
						{ 
			//			alert('newToggler te.status:' + te.status );
						if( te.status )
							{
							te._hide();
							}
						});
					}
				},
 			});
			
	var classtoggle = Class.create({
			// user defineable
			toggleAttr:		'data-newtoggle',
			closeSelector:	'a.newtoggleClose',
			enabledClass:	'newtoggleEnabled',
			disabledClass:	'newtoggleDisabled',
			// named options
			optgroup: 		'group',
			optdefault: 	'default',
			// internal variables, dont change!
			group: 			'',
			containerEl: 	0,
			contentEL: 		0,
			previewEL: 		0,
			status: 		0,
			defaultSet: 	0,
			// functions
			initialize: function( el ) 
				{
 				this.containerEl = el;
				//-----------	read options "[option1][,option2]"
				var options 	= el.readAttribute( this.toggleAttr );
				var optionArr 	= $A(options.split(','));
		//		alert('classtoggle.initialize( options;optionArr: '  + options + '; ' + optionArr.inspect() +' )');
				var optionHash = new Hash();
				optionArr.each( function( opt ){ var oa = $A(opt.split(':',2)); optionHash.set(oa[0],oa[1]);  } );
		//		alert('classtoggle.initialize( options;optionHash: '  + options + '; ' + optionHash.inspect() +' )');
				//---------------- Gruppe
				if( optionHash.get( this.optgroup ) ){ this.group = optionHash.get( this.optgroup ); }
		//		alert('classtoggle.initialize( optgroup;group: ('  + this.optgroup + '); ' + this.group +' )');
				//----------------
				var parts 		= this.containerEl.childElements();
				this.previewEL 	= parts[0];
				this.contentEL 	= parts[1];
				//------------------ set default
		//		alert('classtoggle.initialize( optionHash(default):'  + optionHash.get( this.optdefault ) + '; defaultSet:' + this.defaultSet +' )');
				if( optionHash.get( this.optdefault ) && !this.defaultSet )
						{ this.defaultSet 	= 1; }
				else 	{ this.status 		= 1; }
		//		alert('classtoggle.initialize( optdefault:'  + this.optdefault + '; defaultSet:' + this.defaultSet +'; status:' + this.status +' )');
				//------------------ set togglehandler
				this.ntogglehandler = this.ntogglehandler.bind( this );
				this.previewEL.observe( 'click',  this.ntogglehandler );
				//------------------ infect close links
				$(this.contentEL).select( this.closeSelector ).each(  
						function(elem)
							{
		//					alert( 'classtoggle.initialize(close:link)' + this.togglehandler );
							elem.observe( 'click',  this.ntogglehandler );
							}, this );
				//-------------------
				this._hide();
//				return( this );								
				},
				
			ntogglehandler: function( ev )
				{
			//	alert('classtoggle.initialize( before:: status:' + this.status +' )');
				if( this.status == 0 )
					{		// enable contentEL
					this._show();
					this.status = 1;
					}
				else
					{		// disable contentEL
					this._hide();
					this.status = 0;
					}
				// alert('classtoggle.initialize( after:: status:' + this.status +' )');
				Event.stop( ev );
				},
				
			_show: function( ev )
				{
				if( this.group ){ newToggler.open( this.group, this ); }
				this.containerEl.removeClassName( this.disabledClass )
				this.containerEl.addClassName( this.enabledClass )
				},
				
			_hide: function( ev )
				{
				this.containerEl.removeClassName( this.enabledClass )
				this.containerEl.addClassName( this.disabledClass )
				},
			});
			
//--- class sequencer -------------------------
	var PSsequencer = Class.create({
			//------------------
			containerEl: 	0,
			classesArr: 	[],
			clen:	 		0,
			restoreArr: 	[],
			count: 			-1,
			myTimer: 		0,
			timecontrol: 	0,
			interval: 		1000,
			//------------------
			defaultclass: 	'sequencer',
			activeclass: 	'sequencer-active',
			dataattribute: 'data-sequencer',
			// functions
			initialize: function( el ) 
				{
  	  			//-----------			
				this.containerEl = el;
 								
		 		//-----------	read options "[defaultclass-]class[-class][,option][,option]"
 				var options 	= this.containerEl.readAttribute( this.dataattribute );
 				var optionArr 	= $A(options.split(','));
  				//alert('PSsequencer.initialize( options;optionArr: '  + options + '; ' + optionArr.inspect() +' )');

		 		//-----------	read classes
 				var classstr 	= optionArr.shift();
		//		alert('PSsequencer.initialize( classstr: ' + classstr + ' )');
 				this.classesArr = $A(classstr.split('-'));
				this.clen = this.classesArr.size();
				if( this.clen < 2 ){ return; }
  		//		alert('PSsequencer.read classes( classesArr: ' + this.classesArr.inspect() +' )');

				// initialize Counter
		 		//-----------	read interval
 				var interv 	= optionArr.shift();
		//		alert('PSsequencer.initialize( classstr: ' + interv + ' )');
				interv = parseInt( interv );
				if( interv >= 100 ){ this.interval = interv;}
 				this.timecontrol 	= this.nextstep.bind( this );
				this.myTimer		= setInterval( this.timecontrol, this.interval );
//  			this.myTimer		= setTimeout( this.timecontrol, this.interval );
   		//		alert('PSsequencer.read interval( interval: ' + this.interval +' )');
				//-----------------------------------------------
   		//		alert('PSsequencer.first count( count: ' + this.count +' )');

 				this.nextstep();

				//-----------
 				this.containerEl.addClassName( this.activeclass );
				// end of initialization
 				},

			nextstep: function(  )
				{
				var newPos = this.count + 1;
				// alert('PSsequencer._move( zielposition.0: ' + newPos + ' )');
				//------ check bounds
				if( newPos >= this.clen ){ newPos = 0; }
				//------
				this.count = newPos;
				// alert('PSsequencer._move( zielposition.1: ' + newPos + ' )');
				 //alert('PSsequencer._move( count: ' + this.count + ' )');
				this.containerEl.writeAttribute( 'class',  this.classesArr[newPos] );
				//------			
				},

			});

//--- class cascade -------------------------
	var PScascade = Class.create({
			//------------------
			containerEl: 	0,
			elementsArr: 	[],
			classesArr: 	[],
			restoreArr: 	[],
			start: 			0,
			mid: 			0,
			end: 			0,
			elen:			0,
			clen:	 		0,
			optlinear:		false,
			optclick:		false,
			optnext:		false,
			opthover:		false,
			opthold:		false,
			optfirst:		false,
			optautorun:		false,
			// timer
			myTimer: 			0,
			timerTakt: 			100,
			timerCounter: 		0,
			startTime: 			0,		// set by option auto
			interTime: 			0,		// set by option auto
			waitTime: 			0,		// set by option auto
			//------------------
			optionlinear:	'linear',
			optionclick:	'click',
			optionhover:	'hover',
			optionnext:		'next',
			optionhold:		'hold',
			optionfirst:	'first',
			optionautorun:	'auto',
			defaultclass: 	'cascade',
			activeclass: 	'cascade-active',
			classattribute: 'data-cascade',
			// functions
			initialize: function( el ) 
				{
  	  			//-----------			
				this.containerEl = el;
 		//		this.containerEl.setStyle( 'border: 1px solid red;' );
 				
		 		//-----------	read options "[defaultclass-]class[-class][,option][,option]"
 				var options 	= this.containerEl.readAttribute( this.classattribute );
 				var optionArr 	= $A(options.split(','));
  				//alert('PSslider.initialize( options;optionArr: '  + options + '; ' + optionArr.inspect() +' )');

		 		//-----------	read classes
 				var classstr 	= optionArr.shift();
		//		alert('PScascade.initialize( classstr: ' + classstr + ' )');
 				this.classesArr = $A(classstr.split('-'));
		 		//-----------	default class?
 				if( this.classesArr.size() % 2 == 0)		// if even shift defaultclass
 					{
 					this.defaultclass = this.classesArr.shift();
  		//			alert('PSslider.initialize( classesArr.inspect: ' + this.classesArr + ' )');
  					}
				this.clen = this.classesArr.size();
				if( this.clen == 0 ){ return; }

 		 		//-----------	find childs
				this.elementsArr = this.containerEl.childElements();
				this.elen = this.elementsArr.size();
				if(  this.elen < 2 || this.elen <= this.clen ){ return; }

  		//		alert('PScascade.initialize( elementsArr.inspect: ' + this.elementsArr + ' )');
		//		alert('PScascade.initialize( this.elen/this.clen: ' + this.elen + '/' + this.clen + ' )');

		 		//-----------	set options
				optionArr.each( function( option )
						{ 
						//alert('PScascade.initialize( option:: \'' + option + '\' )');
						if( option == this.optionlinear )
							{ 
							this.optlinear = true; 
							//alert('PScascade.initialize( set optionstr: ' + option + '='  + this.optionlinear +  '::'  + this.optlinear + ' )');
							}
						else if( option == this.optionclick )
							{ 
							this.optclick = true; 
							//alert('PScascade.initialize( set optionstr: ' + option + '='  + this.optionclick +  '::'  + this.optclick + ' )');
							}
						else if( option == this.optionnext)
							{ 
							this.optnext = true; 
							//alert('PScascade.initialize( set optionstr: ' + option + '='  + this.optionclick +  '::'  + this.optclick + ' )');
							}
						else if( option == this.optionhover )
							{ 
							this.opthover = true; 
							//alert('PScascade.initialize( set optionstr: ' + option + '='  + this.optionhover +  '::'  + this.opthover + ' )');
							}
						else if( option == this.optionhold )
							{ 
							this.opthold = true; 
							//alert('PScascade.initialize( set optionstr: ' + option + '='  + this.optionhover +  '::'  + this.opthover + ' )');
							}
						else if( option == this.optionfirst )
							{ 
							this.optfirst = true; 
							//alert('PScascade.initialize( set optionstr: ' + option + '='  + this.optionfirst +  '::'  + this.optfirst + ' )');
							}
						else
							{ 
							var regex = RegExp(/^auto-(.*)-(.*)-(.*)$/);
							var val = regex.exec( option );
							if( val != null && val[1] && val[2] && val[3] )
								{
								this.startTime 	= parseInt( val[1] ) / this.timerTakt;
								this.stepTime 	= parseInt( val[2] ) / this.timerTakt;
								this.waitTime 	= parseInt( val[3] ) / this.timerTakt;
								if( this.stepTime >= 1 )
									{
									this.optautorun = true; 
				//					alert( 'PScascade.initialize.options.timer: waitTime::' + this.waitTime + '"; stepTime::"' + this.stepTime + '"; waitTime::"' + this.waitTime + '";');
									}	
								if( this.startTime < 1 ){ this.startTime = 0; }	
								if( this.waitTime < 1 )	{ this.waitTime = 0; }	
								}
							else
								{
								this.waitTime 	= 0;
								this.stepTime 	= 0;
								this.startTime 	= 0;
								this.optautorun = false; 
								}	
							}
						}, this );
		
	//			alert("PScascade.initialize( options)::'" + this.optionlinear + "'|'"  + this.optlinear + "'; '"  + this.optionclick + "'|'"  + this.optclick + "'; '"  + this.optionnext + "'|'"  + this.optnext + "'; '"  + this.optionhold + "'|'"  + this.opthold + "'; '"  + this.optionhover + "'|'" + this.opthover + "'; '"  + this.optionautorun + "'|'" + this.optautorun + "'; )" );

				if( this.opthover != true || this.optnext != true ){ this.optclick = true; }

 		 		//-----------	set eventhandler
 		 		var ri = 0;
				this.restoreArr = new Array();
				this.elementsArr.each( function(elt)
						{ 
						var ind = this.elementsArr.indexOf(elt);
						//alert('PScascade.initialize( ind:: \'' + ind + '\' )');
//						if( !this.optautorun || true )
						if( !this.optautorun )
							{
							if( this.optnext == true )
								{ elt.observe( 'click', this.movenexthandler.bindAsEventListener( this, ind ) ); }
							else if( this.optclick == true )
								{ elt.observe( 'click', this.movehandler.bindAsEventListener( this, ind ) ); }
								
							if( this.opthover == true  )
								{ elt.observe( 'mouseover', this.movehandler.bindAsEventListener( this, ind ) ); }
							}
						//-----
						this.restoreArr[ri] = (this.opthold == true) ? elt.readAttribute( 'class' ) : '';
						if( this.restoreArr[ri] == null ){ this.restoreArr[ri] = '';}
						ri++;
						}, this );
			
//		if(this.opthold == true){ alert('PSslider.initialize( restoreArr.inspect: ' + this.restoreArr.inspect() + ' )'); }
				//-----------------------------------------------
				if( this.optautorun && this.waitTime > 0 && this.stepTime > 0 )
					{
		//			alert( 'PScascade.initialize.timer1: waitTime::' + this.waitTime + '"; stepTime::"' + this.stepTime + '";');
					this.timecontrol 	= this.timecontroler.bind( this );
					this.myTimer		= setInterval( this.timecontrol, this.timerTakt );
					this.timerCounter 	= this.startTime;
					}	
				else if( this.optautorun && this.waitTime == 0 && this.stepTime > 0  )
					{
		//			alert( 'PScascade.initialize.timer2: waitTime::' + this.waitTime + '"; stepTime::"' + this.stepTime + '";');
					this.timecontrol 	= this.timerrun.bind( this );
					this.myTimer		= setInterval( this.timecontrol, this.stepTime * this.timerTakt );
					this.timerCounter 	= this.startTime;
					}	

 		 		//-----------	set initial position
 				this.mid = this.elen/2;
 	//			this.mid = this.elen/2 + 0.5;
 				if( this.optfirst == true ){ this.mid = 1; }
  		 		this._move( this.mid ) ;
				//-----------
//		if(this.opthold == true){ alert('PSslider.initialization_end( restoreArr.inspect: ' + this.restoreArr.inspect() + ' )'); }
 				this.containerEl.addClassName( this.activeclass );
				// end of initialization
 				},

			timecontroler: function()
				{
		//		alert( 'timecontroler:start:: ' + this.timerCounter );
				if( this.timerCounter >= 0 )
					{
					if( this.timerCounter > this.waitTime )
						{
						this.timerCounter = -1;
			//			alert( 'timecontrol:check:a:: ' + this.timerCounter );
						this.timermove( this.mid );
			//			alert( 'timecontrol:check:b:: ' + this.timerCounter );
						}
					else
						{ 
						this.timerCounter++; 
						}
			//		alert( 'timecontrol:waiting:: ' + this.timerCounter );
					}
				else
					{ 
			//		alert( 'timecontrol:active::-a ' + -this.timerCounter + '-von-' + this.stepTime );
					if( -this.timerCounter > this.stepTime )
						{
						this.timerCounter = -1;
						this.timermove( this.mid );
						}
					else
						{ 
						this.timerCounter--; 
						}
			//		alert( 'timecontrol:active::b ' + this.timerCounter );
					}
		//		alert( 'timecontroler:active::b ' + this.timerCounter );
				},
				
			resettime: function()
				{
				this.timerCounter = 1;
		//		alert( 'resettime:: ' + this.timerCounter );
				},
				
			timerrun: function()
				{
		//		alert( 'timermove:: ' + this.timerCounter );
				this._move(  this.mid + 1 );
				},

			timermove: function( newMid )
				{
		//		alert( 'timermove:: ' + this.timerCounter );
				this._move( newMid + 1 );
				},

			movehandler: function( ev, newMid )
				{
	//			alert('PScascade.movehandler( zielposition: ' + newMid + '/' + this.mid  + '; )');
				this._move( newMid + 1 );
				this.resettime();
				},

			movenexthandler: function( ev, newMid )
				{
	//			alert('PScascade.movenexthandler( zielposition: ' + newMid + '/' + this.mid  + '; )');
				if( (newMid + 1) == this.mid )
					{ 
					this._move( newMid + 2 ); 
					}
				this.resettime();
				},

			_move: function( newMid )
				{
//				if(this.opthold == true){ alert('PSslider._move( restoreArr.inspect: ' + this.restoreArr.inspect() + ' )'); }
		//		alert('PScascade._move( zielposition: ' + newMid + ' )');
				//------ check bounds
				if( newMid < 0 )
					{ 
					newMid = this.linear ? 1 : (this.elen + newMid); 
		//			alert('PScascade._move(a korr. zielposition: ' + newMid + ' )');
					}
				if( newMid > this.elen )
					{ 
					newMid = this.linear ? (this.elen) : (newMid - this.elen); 
		//			alert('PScascade._move(b korr. zielposition: ' + newMid + ' )');
					}
				//------
				var  diff	= this.clen/2 + 0.5;
				var  co_ind	= 0;
				var  cn_ind	= 0;
				var  startn	= 0;
//				alert('PScascade._move( newMid/startn/diff: ' + newMid + ' / ' + startn  + ' / ' + diff + ' )');
				//------

				if( (newMid - diff) < 0 )		// mid am anfang
					{
					startn = 0;
					cn_ind = - newMid + diff;
					}
				else if( (newMid + diff - 1) > this.elen && this.optlinear != true )	// mid am ende
					{
					startn = 0;
					cn_ind = (this.elen - newMid) + diff;
					}
				else							// mid mittendrin
					{
					cn_ind = 0;
					startn	= newMid - diff;   //????
					}
		//		alert('PScascade._move( diff/newMid/startn/cn_ind: ' + diff + ' / ' + newMid  + ' / ' + startn + ' / ' + cn_ind + ' )');
								
				//-------
				var  ei=0;
				var  ni=0;
				var  oi=0;
		//		alert('PSslider._move( restoreArr.inspect: ' + this.restoreArr.inspect() + ' )');
				for( ei; ei < this.elen; ei++ )
					{
		//			alert('PScascade._move( for: ei/ni/cn_ind/startn:: '+ ei + ' / '  + ni + ' / ' + cn_ind + ' / ' + startn + ' )');
		//			alert('PScascade._move( for: ei/starto/oi/clen:: '+ ei + ' / ' + starto + ' / '   + oi + ' / ' + this.clen + ' )');
					
					if( cn_ind >= this.clen && this.optlinear != true )
						{
			//			alert('PScascade._move( for: ei/startn/cn_ind:: '+ ei + ' / ' + startn + ' / '   + cn_ind + ' )');
						startn = this.elen - (this.clen - ni );
						cn_ind = 0; 
		//				alert('PScascade._move( for: ei/startn/cn_ind:: '+ ei + ' / ' + startn + ' / '   + cn_ind + ' )');
						}
					if( ei >= startn && ni < this.clen && cn_ind < this.clen )
						{
						this.elementsArr[ei].writeAttribute( 'class', this.restoreArr[ei] + ' ' + this.classesArr[cn_ind] );
						cn_ind++;
						ni++;
						}
					else
						{
						this.elementsArr[ei].writeAttribute( 'class',  this.restoreArr[ei] + ' ' + this.defaultclass );
						}
					}
				this.mid = newMid;
				//------			
				},

// 			_nexthandler: function( ev )
// 				{
// 				this._move( newMid + 2 );
//  				Event.stop( ev );
// 				return false;
// 				},
// 
// 			_prevhandler: function( ev )
// 				{
// 				this._move( newMid );
// 				Event.stop( ev );
// 				return false;
// 				},
			});
			
 
//--- async load content -------------------------

	var PSasync = Class.create({
			// 
			// Element classes (user defineable)
			// Status classes (user defineable)
			defaultClass: 	'as_default',
			activeClass: 	'as_active',
			onceClass: 		'as_once',
			loadClass: 		'as_loaded',
			topClass: 		'as_top',
			addClass: 		'as_bottom',
			beforeClass: 	'as_before',
			afterClass: 	'as_after',
			errClass: 		'as_error',
			asyncData: 		'data-async',
			// internal variables, dont change!
			viewportID: 	'',
			el: 			'',
			dataHREF: 		'',
			insertMode: 	'',			// 'bottom', 'top'
			loadMode: 		0,			//
			//------------------------------
			// functions
			initialize: function( el ) 
				{
				this.el = el;
				//alert('found sync!');
				this.dataHREF 	= el.readAttribute(this.asyncData);
				//
				var regex = RegExp(/^(.*)#(.*)$/);
				var val = regex.exec( this.dataHREF );
				if( val != null && val[1] )
					{
					this.dataHREF = val[1];
					if( val != null && val[2] )
						{
						this.viewportID = val[2];
						$(this.viewportID).addClassName( this.activeClass ); 
						}
					else { alert("async no par 2"); return;}
					}
				else { alert("async no par 1"); return;}
				//
				if( el.hasClassName( this.topClass ) )
					{ this.insertMode = 'top'; }
				else if( el.hasClassName( this.addClass ) )
					{ this.insertMode = 'bottom'; }
				else if( el.hasClassName( this.beforeClass ) )
					{ this.insertMode = 'before'; }
				else if( el.hasClassName( this.afterClass ) )
					{ this.insertMode = 'after'; }
				//
				if( el.hasClassName( this.onceClass ) )
					{ this.loadMode = 1; }
				else { this.loadMode = 0; }
				//alert('inspect this: viewportID:' + this.viewportID + '; dataHREF:' + this.dataHREF + ''  );
				//	
				this.bound = this.async_handler.bindAsEventListener( this ) ;
				this.el.observe( 'click', this.bound  );
				this.el.addClassName( this.activeClass ); 
				},

			async_handler: function( ev ) 
				{	
		//		alert('async_handler.insertMode' + this.insertMode);
				var myAjax = new Ajax.Updater(
				  		this.viewportID, 
				  		this.dataHREF, 
				  		{ 
				  			method: 'get'
				  		//	,parameters: ''  
				  		//	,insertion: Insertion.(this.insertMode)
				  			,insertion: this.insertMode
				  			,evalScripts: true
  						//	,insertion: 'bottom'				  		
  						}
				  	);
// 				Ajax.Responders.register( {onComplete: function()
// 					{
// 				//alert("updateImageList:" );
// 					lightbox.updateImageList();
// 					$(imageshow_id).style.backgroundColor="#FFF";
// 					}});
				if( this.loadMode )
					{ 
					this.el.addClassName( this.loadClass ); 
					this.el.stopObserving('click',  this.bound ); 
					}
				Event.stop(ev);
				return( false );
				}				
			});
			
//----------------------------------------------------------------------

	var Persistance;
	
	var PSpersist = Class.create({
			// internal variables, do not change!
			groupHash: 			0,
			persistIdClass: 	'.cs-persist',
			persistAttr: 		'data-persist',
			// functions
			initialize: function( psid ) 
				{
				this.groupHash = new Hash()
		//		alert( 'Toggle el:' + $$( this.persistIdClass ).inspect() );
				if( psid ){ this.persistIdClass = psid + ' [' + this.persistAttr + ']'; }
				$$( this.persistIdClass ).each( function(el)
					{ 
		//			alert( 'Toggle el:' + el.inspect() );
					var newt = new PSpers( el );	
					if( newt.persistGroup )
						{
						var g = newt.persistGroup;
		//				alert('Toggle g:' + g );
						if( !this.groupHash.get( g ))
							{
			//				alert('Toggle neuer Hasheintrag' );
							this.groupHash.set( g, [] );
			//				var queue = new
							}
						var gh = this.groupHash.get( g );
						gh.push( newt );
		//				alert('PSpersist gh:' + gh.inspect() );
						}
					}, this );
		//		alert('PSpersist groupHash:' + this.groupHash.inspect() );
				},
			open: function( gr, tobj ) 
				{
				if( this.groupHash.get( gr ) )
					{
					var garr = this.groupHash.get( gr );
		//			alert('Toggle open  garr:' + garr.inspect() );
					garr.each( function(te){ te.close(); }  );
					}
				},
 			});
			
	var PSpers = Class.create({
			// user defineable
			persistIdClass: 		'persist-active',
			persistOffClass: 		'cs-persist-off',
			persistOnClass:			'cs-persist-on',
			// internal variables, don't change!
			persistGroup: 	'',
			El: 			0,
			// functions
			initialize: function( el ) 
				{
				this.El = el;
				var classarr = $w(el.className);
				var regex = RegExp(/^cs-group-(.*)$/);
				classarr.each( function(cl)
						{
			//			alert('Toggle search:' + cl );
						if( !this.persistGroup )
							{  
							var val = regex.exec(cl);
							if( val != null && val[1] )
								{
								this.persistGroup = val[1];
								}						
							}
						}, this );
			//	alert( 'Toggle Groupname is:"' + this.persistGroup + '";');
								
				this.lpersist = this.lpersist.bind( this );
				this.El.observe( 'click',  this.lpersist );
				//----------------------------
				this.El.removeClassName( this.persistIdClass )
				this.El.addClassName( this.persistOffClass )
				},
			lpersist: function( ev )
				{
		//		alert('lpersist():' );
				if( this.El.hasClassName( this.persistOffClass )  )
					{
					if( this.persistGroup ){ Persistance.open( this.persistGroup, this ); }
					//--------------------------
					this.El.removeClassName( this.persistOffClass )
					this.El.addClassName( this.persistOnClass )
					}
				else if( this.El.hasClassName( this.persistOnClass ) )
					{
					this.El.removeClassName( this.persistOnClass )
					this.El.addClassName( this.persistOffClass )
					}
				Event.stop( ev );
				},
			close: function( el )
				{
		//		alert('close():' );
				if( this.El.hasClassName( this.persistOnClass ) )
					{
					this.El.removeClassName( this.persistOnClass )
					this.El.addClassName( this.persistOffClass )
					}
				},
			});
			

 //----------------------------------------------------------------------
//
// shoppingcart.js v0.1.0 16.12.2010 10.02.2011 by Gerd Franke franke@sitescriptor.de
// implements a client-side persistent shopingcart using cookies
// depends on prototype.js V1.63
//
// ToDos: 		
//				URL-encodierte Platzhalter
// PROBLEME:
//				Doku!
//
// DONE:
//				addhandler: hinzufuegen nur mit pid
// 				Summe ueber alle Teile bilden
//				in addhandler: dataH: '+' in Leerzeichen wandeln
// 				Ausblenden der Artikelliste fehlt noch
//				...templates
// 				_drawcart stellt nach addhandler >1 nicht korrekt dar
// 
//------------------------------------------------------------------------------------------
//--------- http://codeinthehole.com/archives/5-Javascript-cookie-objects-using-Prototype-and-JSON.html
var Cookies = Class.create({
    initialize: function(path, domain) {
        this.path = path || '/';
        this.domain = domain || null;
    },
    // Sets a cookie
    set: function(key, value, days) {
        if (typeof key != 'string') {
            throw "Invalid key";
        }
        if (typeof value != 'string' && typeof value != 'number') {
            throw "Invalid value";
        }
        if (days && typeof days != 'number') {
            throw "Invalid expiration time";
        }
        var setValue = key+'='+escape(new String(value));
        if (days) {
            var date = new Date();
            date.setTime(date.getTime()+(days*24*60*60*1000));
            var setExpiration = "; expires="+date.toGMTString();
        } else var setExpiration = "";
        var setPath = '; path='+escape(this.path);
        var setDomain = (this.domain) ? '; domain='+escape(this.domain) : '';
        var cookieString = setValue+setExpiration+setPath+setDomain;
        document.cookie = cookieString;
    },
    // Returns a cookie value or false
    get: function(key) {
        var keyEquals = key+"=";
        var value = false;
        document.cookie.split(';').invoke('strip').each(function(s){
            if (s.startsWith(keyEquals)) {
                value = unescape(s.substring(keyEquals.length, s.length));
                throw $break;
            }
        });
        return value;
    },
    // Clears a cookie
    clear: function(key) {
        this.set(key,'',-1);
    },
    // Clears all cookies
    clearAll: function() {
        document.cookie.split(';').collect(function(s){
            return s.split('=').first().strip();
        }).each(function(key){
            this.clear(key);
        }.bind(this));
    }
});

var JsonCookies = Class.create(Cookies, {});
JsonCookies.addMethods({
    // Overridden set method to JSON-encode value
    set: function($super, key, value, days) {
        switch (typeof value) {
            case 'undefined':
            case 'function':
            case 'unknown':
                throw "Invalid value type";
                break;
            case 'boolean':
            case 'string':
            case 'number':
                value = String(value.toString());
            break;
        }
        $super(key, Object.toJSON(value), days);
    },
    // Overriden get method to JSON-decode the value
    get: function($super, key) {
        var value = $super(key);
        return (value) ? value.evalJSON() : false;
    }
});
/*
var date = new Date(date.getTime() +1000*60*60*24*14);
document.cookie = 'meincookie=meinwert; expires='+date.toGMTString()+';'; 


if(document.cookie){ machwas(); } 

var cookieobj = document.cookie;
cookiename = cookieobj.substr(0,cookieobj.search('='));
cookiewert = cookieobj.substr(cookieobj.search('=')+1,cookieobj.search(';'));
if(cookiewert == '')
	{
	cookiewert = cookieobj.substr(cookieobj.search('=')+1,cookieobj.length);
	} 
*/
//--------- http://codeinthehole.com/archives/5-Javascript-cookie-objects-using-Prototype-and-JSON.html
//------------------------------------------------------------------------------------------

var cookieObj;
			
	var PScart = Class.create({
			// Element classes (user defineable)
			cartClass: 			'sc-cart',
			cartOnClass:		'sc-cart sc_active',
			addlinkSelector: 	'sc-cart-add[rel="',
			removeSelector: 	'sc-cart-remove[rel="',
			// special template placeholder names
			pid: 				'pid',
			price: 				'preis',
			num: 				'num',
			// summary
			items: 				'anzahl',
			sum: 				'sum',
			pieces: 			'teile',
			// template placeholder syntax
			syntaxTmpl: 		/(^|.|\r|\n)(%%\s*(\w+)\s*%%)/,
			// internal variables, dont change!
			defaultSet: 		0,
			cartboxID: 			'',
			cartboxEl: 			0,
			containerEl: 		0,
			cartItemsH: 		0,
			// Template
			tmplTop: 			'',
				tmplLoop: 		'',
			tmplBottom: 		'',
			tmplSum: 			'',
			tmplEmpty: 			'',
			// functions
			initialize: function( el ) 
				{
				var defaultSet = 0;
  	  			//-----------
 				this.cartItemsH 	= new Hash();
				this.cartboxEl 		= el;
  				this.cartboxID 		= this.cartboxEl.readAttribute('id');
 				//-----------	Flle Template
 				if( !this.cartboxEl.empty() )
 					{
	 				var content	= this.cartboxEl.innerHTML;
					var lines = content.split(/\r\n|\r|\n/) 				
// 				alert('PScart.initialize(' + content + '):content!'  );
					this.tmplTop	= lines[1] || '';
					this.tmplLoop	= lines[2] || '';
					this.tmplBottom	= lines[3] || '';
					this.tmplSum	= lines[4] || '';
					this.tmplEmpty	= lines[5] || '';
					this.cartboxEl.innerHTML = '';
					}
 				//-----------		
		//		alert('PScart.initialize(START! cartboxID::' + this.cartboxID + '; )' );

 				//-----------	suche zu dieser cartbox passende addlinks/removelinks		
  				this.removeSelector = 'a.' + this.removeSelector + this.cartboxID + '"]';
  				this.addlinkSelector = 'a.' + this.addlinkSelector + this.cartboxID + '"]';
  				this._sethandler( '' );
 				//-----------	activate shoppingcart
				this.cartboxEl.removeClassName( this.cartClass );
				this.cartboxEl.addClassName( this.cartOnClass );
  				//-----------	
				this._readcookie();
				this._drawcart();
  				//-----------			
//			 	alert('PScart.initialize(' + this.cartboxID + '):END!'  );
				},

			_sethandler: function( where )
				{
  				var selector = '';
 				//-----------	suche in dieser cartbox passende addhandler		
  				selector = where + ' ' + this.addlinkSelector;
//				alert( this.cartboxID + '::_sethandler:: ' + selector + ';' );
				$$( selector ).each( function(al)
						{ 
//						al.setStyle( 'text-decoration: line-through;' );
						al.observe( 'click', this.addhandler.bindAsEventListener( this, al ) );
						}, this );
 				//-----------	suche in dieser cartbox passende removehandler		
  				selector = where + ' ' + this.removeSelector;
//				alert( this.cartboxID + '::_sethandler:: ' + selector + ';' );
				$$( selector ).each( function(al)
						{
//						al.setStyle( 'text-decoration: underline;' );
						al.observe( 'click', this.removehandler.bindAsEventListener( this, al ) ); 
						}, this );
				},

			_drawcart: function(  )
				{
				var output	= '';
				var summe	= 0;
				var anzahl	= 0;
				var teile	= 0;
			//----------
//	alert( this.cartboxID + '._drawcart(START!):cartItems:: ' + this.cartItemsH.size() + ';');
				if( this.cartItemsH.size() > 0 )
					{
					var loop = new Template( this.tmplLoop, this.syntaxTmpl );
					this.cartItemsH.each( function (d)
						{
						anzahl++;
						data = $H( d.value );
						teile += data.get( this.num );
						//----------
						output += loop.evaluate(data);
						summe += parseFloat( data.get( this.price) ) * parseFloat( data.get( this.num ) );
						}, this );
					summe = summe.toFixed(2);
					var sum = $H();
					sum.set( this.sum, summe );
					sum.set( this.items, anzahl );
					sum.set( this.pieces, teile );
					var tsum = new Template( this.tmplSum, this.syntaxTmpl );
					output += tsum.evaluate(sum);
					output = this.tmplTop + output + this.tmplBottom;
					}
				else{ output = this.tmplEmpty; }
				this.cartboxEl.update( output );
				
 				//-----------	suche in dieser cartbox passende add-/removehandler		
  				this._sethandler( '#' + this.cartboxID );
				//-------
				return false;
				},				

			_readcookie: function(  )
				{
  				var items = cookieObj.get( this.cartboxID + '-items=' );
				//----------
  				if( items )
  					{ 
  					this.cartItemsH = $H( items ); 
 					//alert('_readcookie::items defined!'); 
  					}
				else
					{
 					this.cartItemsH = new Hash();
 					//alert('_readcookie::no cookie input!'); 
					}
				return;
				},

			_setcookie: function(  )
				{
				cookieObj.set( this.cartboxID + '-items=', this.cartItemsH, 14 );
				return;
				},
				
//-------- Event Handler


			addhandler: function( ev, itemlinkEl )
				{
				//----------
				var itemdata = itemlinkEl.readAttribute('href');
				var dataH = $H( itemdata.toQueryParams() );
				//----------
				var addpid = dataH.get( this.pid );

	  			var item = $H( this.cartItemsH.get(addpid) );
  				if( item.size() > 0 )
 					{		// increment num
					var anz = item.get(this.num);
					item.set( this.num, anz+1 );
					this.cartItemsH.set( addpid, item );
					}
				else		// new item
					{
					dataH.set(this.num, 1);
					this.cartItemsH.set( addpid, dataH );
//					alert( this.cartboxID + '.addhandler( NEWa: cartItemsH.addpid:: "' + dataH.inspect() + ' )');
//					alert( this.cartboxID + '.addhandler( NEWb: cartItemsH.addpid:: "' + this.cartItemsH.get(addpid).inspect() + ' )');
					}
				//----------
				this._drawcart();
				this._setcookie();
				Event.stop( ev );
				return false;
				},
				
			removehandler: function( ev, itemlinkEl )
				{
				var itemdata = itemlinkEl.readAttribute('href');
				var dataH = itemdata.toQueryParams();
				//----------
				var removepid = dataH.pid;
	  			var item = $H( this.cartItemsH.get(removepid) );
  				if( item )
  					{		// decrement num
  					var anz = item.get('num');
//					alert('removehandler(1 anz: "' + anz + ' )' );
  					if( anz > 1 )
  						{
						item.set('num', anz-1 );
 						this.cartItemsH.set( removepid, item );
  						}
  					else
  						{
  						this.cartItemsH.unset( dataH.pid );
  						}
  					}
				//----------
				this._drawcart();
				this._setcookie();
				Event.stop( ev );
				return false;
				},
			});

//----------------------------------------------------------------------

//----- I N I T I A L I Z E   A L L ---------------------------------------

function psinit( psid )
	{
	if( psid ){ psid = psid +  ' '; }
	//	alert( 'pagescriptor loading!;' );
	//---------------------
	cookieObj = new JsonCookies();
	$$( psid + 'div.sc-cart').each( function(el){ var obj = new PScart( el ); } );
	$$( psid + 'a[data-async]').each( function(el){ var obj = new PSasync( el ); } );
	//---------------------
//	newToggler = new newtoggler( psid );
	Persistance = new PSpersist( psid );
	$$('ul[data-cascade], div[data-cascade]').each( function(el){ new PScascade( el );  } );
 	$$('ul[data-sequencer], div[data-sequencer]').each( function(el){ new PSsequencer( el );  } );
	}
		

document.observe( "dom:loaded", function(){ psinit(''); } );	


//----- T H E   E N D ---------------------------------------

